'use strict'

const { program } = require('commander');
const fs = require('fs')
const diffParse = require('parse-diff')

const app = {
  run() {
    program
      .version('1.0.3')
      .description('Compares the diff patch to indentify which federtated modules were changed and needs to be buil')
      .option('-d, --diff <diff>', 'The diff patch file ', 'diff.patch')
      .option('-w, --workspaces <workspaces>', 'The workspaces path from the root', '')
    program.parse(process.argv)
    const options = program.opts()
    const FULL_TESTS = 'fullTests'

    this.validateOptions(options)

    let diffstring = fs.readFileSync(options.diff, "utf8")

    var diffFile = diffParse(diffstring)
    
    var fullTests = diffFile.flatMap(n => n.to)
    .filter( n => !n.includes(options.workspaces+"/"))
    .filter( n => !n.includes("config/pipeline"))
    .filter( n => !n.includes("yarn.lock"))
    .filter( n => !n.includes(".editorconfig"))
    .filter( n => !n.includes("scripts/"))
    .filter( n => !n.includes(".sh"))

    var modules = []

    if(fullTests.length > 0) {
      modules = [FULL_TESTS]
    } else {
      modules = diffFile.flatMap(n => n.to).filter(n => n.includes(options.workspaces+"/")).map(n => n.substring(n.indexOf(options.workspaces+"/")+options.workspaces.length+1, n.length)).map(n => n.substring(0, n.indexOf("/")))
    }
    var modulesSet = new Set(modules)
    if (modulesSet.size == 0) {
      modulesSet.add(FULL_TESTS)
    }
    
    process.stdout.write(`{{${[...modulesSet].join(' ')}}} \n`)

    process.exit(0);
  },
  validateOptions: function(options)
  {
    if(!options.workspaces)
    {
      console.log("The workspaces path is mandatory, no project path option passed on -p");
      process.exit(1);
    }
    
  }
}

module.exports = app;
